_DoBP=0                 (* Should a stackframe be generated? *)
(*%T c86*)              (* See e.g. new Asmlib.a , Lib$HashString *)
 _DoBP=1                (* or PRAGMA.DOC chapter 5 *)
(*%E*)
(*%F RegParam*)
 _DoBP=1
(*%E*)

ovrcs=2EH          (*overrides*)
ovres=26H

(*%T c286plus*)   (* codes only visible when 286+*)
push8    =6AH            (* push direct 8-bits *)
push16   =68H            (* push direct 16-bits*)
repinsb  =6CF3H;   repinsw   =6DF3H
repoutsb =6EF3H;   repoutsw  =6FF3H
insb     =6CH;     insw      =6DH;       insd   =6D66H
outsb    =6EH;     outsw     =6FH;       outsd  =6F66H
pusha    =60H
popa     =61H
enter    =0C8H         (*db enter; dw 35; db0	 results in enter 0035H,0 *)
leave    =0C9H
ext386   =66H
cpuid    =0A20FH
                          (* dw shlax ; db 8 results in shl ax,8*)
shlax    =0E0C1H;  shlbx    =0E3C1H;  shlcx    =0E1C1H;  shldx    =0E2C1H;
shlsi    =0E6C1H;  shldi    =0E7C1H;
shrax    =0E8C1H;  shrbx    =0EBC1H;  shrcx    =0E9C1H;  shrdx    =0EAC1H;
rolax    =0C0C1H;  rolbx    =0C3C1H;  rolcx    =0C1C1H;  roldx    =0C2C1H;
rorax    =0C8C1H;  rorbx    =0CBC1H;  rorcx    =0C9C1H;  rordx    =0CAC1H;
shrsi    =0EEC1H;

shral    =0E8C0H;  shrbl    =0EBC0H;  shrcl    =0E9C0H;  shrdl    =0EAC0H;
shlal    =0E0C0H;  shlbl    =0E3C0H;  shlcl    =0E1C0H;  shldl    =0E2C0H;
rolal    =0C0C0H;  rolbl    =0C3C0H;  rolcl    =0C1C0H;  roldl    =0C2C0H;
roral    =0C8C0H;  rorbl    =0CBC0H;  rorcl    =0C9C0H;  rordl    =0CAC0H;

shlah    =0E4C0H;  shlbh    =0E7C0H;  shlch    =0E5C0H;  shldh    =0E6C0H;


shrsi    =0EEC1H

setc     =920FH
setb     =920FH
setnc    =930FH
setae    =930FH
sete     =940FH         (* dw sete ; db aal results in sete al *)
setne    =950FH
 aal      =0C0H;       abl    =0C3H;      acl    =0C1H;     adl    =0C2H
(*%E*)
