IMPLEMENTATION MODULE GeLib;

FROM ELib IMPORT GetKey,StrStr;
FROM Str IMPORT Item,Length,Append,Copy,ItemS,Delete,Match,Concat,Insert;
FROM FIO IMPORT Exists;
FROM IO IMPORT WrChar,WrStr,WrCharRep;
FROM Lib IMPORT EnvironmentFind;
FROM Window IMPORT WinDef,WinType,Yellow,White,LightGray,TextColor,GotoXY;
FROM CoreCrt IMPORT SetCurSize;
IMPORT Window;

CONST CR     = 13;
      ESC    = 01BH;
      BS     = 8;
      DELete = 05300H;
      ArrL   = 04B00H;
      ArrR   = 04D00H;
      INSert = 05200H;
      Home   = 04700H;
      End    = 04F00H;
      CtrlY  = 19H;


      AboutStr ="Ge  Version 1.01 ";
      AboutStr1="By Marco van de Voort";
      AboutStr2="Special thanx to Mark Leenders";
      AboutStr3="and Andreas Reinicke";
      AboutStr4="(C) 1993  ";

PROCEDURE VraagVeld(D:InvoerRec;VAR S:ARRAY OF CHAR):BOOLEAN;

(* Since I'm in a hurry, I'll only translate the procedure heading:

  Input a string from keyboard, in a nice way,
   allowed characters are in CHARSET D.Toegestaan, but several editting
   keys are always allowed, see CASE loop.

Theoretical limit of 80 characters, but this isn't tested, so you could reach
132 characters if you wish, but you'll have to make "UitG" bigger.

Parameters:

   X,Y Coordinates field
   Len   Lengte field
   Flags   Extra data:
         0 "S" is not empty and contains a default string
         1 Insert is on. *)

VAR
    InGev                     : CARDINAL; (* No. of chars inputted *)
    Posi                      : CARDINAL; (* Cursorposition*)
    Ins                       : BOOLEAN;  (* Insert yes/no *)
    Key                       : CARDINAL; (* Last key as ELib.GetKey
    				              code <255 if normal key,
    				                   >256 if special/function
    				                   key. See header TLIB.DEF*)
    Uitg                      : ARRAY[0..81] OF CHAR; (* The inputted string*)
    Full                      : BOOLEAN;   (* Is the string full? *)

    I                         : CARDINAL;  (* Temporary variabele *)


PROCEDURE ReWr(); (* Rewrite the field, using Uitg*)

BEGIN
 Delete(Uitg,D.Len,Length(Uitg));
 IF Length(Uitg)>0 THEN
  FOR I:= 0 TO Length(Uitg)-1 DO
   GotoXY(D.X+I,D.Y);
   IF Uitg[I]=CHR(32) THEN
    WrChar(CHR(FieldSpace));
   ELSE
    WrChar(Uitg[I]);
    END;
   END;
  END;
 GotoXY(D.X+Length(Uitg),D.Y);
 WrCharRep(CHR(FieldSpace),D.Len-Length(Uitg));
END ReWr;

PROCEDURE DoCursor; (* Put Cursor in/out insert-mode *)

BEGIN
 IF Ins=TRUE THEN
  SetCurSize(1,30);
 ELSE
  SetCurSize(7,30);
  END;
END DoCursor;

BEGIN
 WITH D DO

    (* Init *)

  InGev :=0;	 	   (* 0 chars untill now *)
  Posi  :=0;               (* Cursorposition 0 *)
  Ins   :=Flags[1];        (* Insert according to parameters *)
  DoCursor;		   (* Set cursor accordingly *)
  Key   :=0;

       (* put  padded field on screen *)

  StrStr(Uitg,CHR(FieldSpace),Len);
  ReWr;
  GotoXY(X,Y);

  StrStr(Uitg,CHR(0),80);                  (* Empty Uitg entirely *)

  IF Flags[0]=TRUE THEN
   Concat(Uitg,S,"");
   Posi:=Length(S);                        (* Put a predefined *)
   ReWr;                                   (*  String on screen if specified *)
   END;


  LOOP
   Full:=FALSE;

   IF ((Posi+1)>Len) THEN
    Full:=FALSE;
    Posi:=Len-1;
    END;

   GotoXY(X+Posi,Y);
   Key:=GetKey();
   CASE Key OF
    |      CR              : Concat(S,Uitg,"");        (*Type conversion, *)
                             RETURN TRUE;      (* I had problems with Str.Copy*)
    |      ESC             : RETURN FALSE;
    |      BS              : IF NOT (Posi=0) THEN       (* BackSpace *)
                              DEC(Posi);
                              Delete(Uitg,Posi,1);
                              DEC(InGev);
                              ReWr;
                              END;
    |      DELete          : Delete(Uitg,Posi,1);
                             DEC(InGev);
                             ReWr;
    |      ArrR            : IF (NOT Full) AND (Posi<InGev) THEN
                              INC (Posi);
                              GotoXY(X+Posi,Y);
                              END;
    |      INSert          : Ins:= NOT Ins;
                             DoCursor;
    |      ArrL            : IF (NOT (Posi=0)) THEN
                              DEC (Posi);
                              GotoXY(X+Posi,Y);
                              END;
    |      Home            : Posi:=0;
    |      End             : Posi:=InGev-1;
    |      CtrlY           : Delete(Uitg,Posi+1,Length(Uitg)-Posi-1);
                             ReWr;

    END;
   IF (CHR(Key) IN Toegest) AND (Full=FALSE)THEN
    IF Ins=FALSE THEN
     Uitg[Posi]:=CHR(Key);
    ELSE
     Insert(Uitg,CHR(Key),Posi);	
     END;
    ReWr;
    INC(Posi);
    END;
   IF InGev<Posi THEN
    InGev:=Length(Uitg);
    END;
   END;
  END;
END VraagVeld;

PROCEDURE About;

CONST WD=WinDef(15,10,65,18,Yellow,LightGray,FALSE,TRUE,FALSE,TRUE,
                              Window.SingleFrame,White,LightGray);

VAR
    Win : WinType;
    A	       : CARDINAL;

BEGIN
 Win := Window.Open(WD) ;
 Window.SetTitle(Win,' About ',Window.CenterUpperTitle);
 Window.PutOnTop(Win) ;
 Window.Use(Win);

 A:=WD.X2-WD.X1-2;
 TextColor(Window.Yellow);
 GotoXY((A-Length(AboutStr )) DIV 2,1);
 WrStr(AboutStr );
 TextColor(Window.LightBlue);
 GotoXY((A-Length(AboutStr1)) DIV 2,3);
 WrStr(AboutStr1);
 GotoXY((A-Length(AboutStr2)) DIV 2,4);
 WrStr(AboutStr2);
 GotoXY((A-Length(AboutStr3)) DIV 2,5);
 WrStr(AboutStr3);
 TextColor(Window.White);
 GotoXY((A-Length(AboutStr4)) DIV 2,7);
 WrStr(AboutStr4);
 A:=GetKey();
 Window.PutOnTop(Window.FullScreen);
 Window.Use(Window.FullScreen);
 Window.Close(Win);
END About;

END GeLib.