MODULE Smooth;
(* Demo CoreSmooth module. XtdLib package (C) by Marco van de Voort 1997

Originally by Bas van Gaalen & Sven van Heel, the font part(big letters) is
added by me, the old source used one line.

The original source DIDN'T flicker in the first line. I don't know why
this one does. TopSpeed just a bit slower or faster on a critical moment?
The assembler parts(CoreSmooth) are almost the same??

Portability : None. More an example how to avoid portability:-)
*)

FROM CoreSmooth IMPORT SetupSmooth,SetAddress,SetSmooth,DoLine;
FROM CoreFont   IMPORT CoreFont;
FROM CorePal    IMPORT VertRetrace;
FROM Str        IMPORT Length;
FROM CoreCrt    IMPORT GotoXY;
FROM Lib        IMPORT RANDOMIZE,Move,RANDOM,Delay,ParamCount,ParamStr;
FROM Storage    IMPORT ALLOCATE;

IMPORT IO,FIO;

TYPE ArrMask    =       ARRAY[0..7] OF BYTE;
     Font       =       ARRAY[0..4095] OF BYTE;
     FontPtr    = POINTER TO Font;

CONST Mask=ArrMask(128,64,32,16,8,4,2,1);

PROCEDURE DoASmoothScroll(S:ARRAY OF CHAR;Fnt : FontPtr);

CONST lines=25;

VAR     x,y,i  : CARDINAL;
        LenStr,
        CurChar,
        CurLine:CARDINAL;
BEGIN
  CurChar:=0; CurLine:=0;
  LenStr:=Length(S);
  SetupSmooth(lines*16);
  SetAddress((25-lines)*80);
  GotoXY(1,1);
  x:=0;
  FOR y:=0 TO 24 DO
   GotoXY(0,y);
   IO.WrChar(" ");
   END;
  RANDOMIZE;
  REPEAT
    VertRetrace;
    SetSmooth(BYTE(x));
    INC(x);
    IF x=9 THEN
     x:=0;
      DoLine(lines);
      FOR y:=0 TO lines-1 DO
       [0B800H:(25-lines+y)*160+158]^:=32+256*15;
        END;
      FOR y:=0 TO 15 DO
       IF Fnt^[ORD(S[CurChar])<<4+y] AND Mask[CurLine] >BYTE(0)
        THEN
       [0B800H:(30-lines+y)*160+158]^:=178+256*15;
       END;
       END;
        INC(CurLine);
        IF CurLine=8 THEN
         CurLine:=0;
         INC(CurChar);
         IF CurChar=LenStr THEN
          CurChar:=0;
          END;
         END;
     END;
  UNTIL IO.KeyPressed();
END DoASmoothScroll;

VAR Fnt : FontPtr;
    S   : ARRAY[0..100] OF CHAR;
    F   : FIO.File;
    A   : CARDINAL;

BEGIN
 NEW(Fnt);
 IF ParamCount()<0 THEN
  CoreFont.GetSetFont(0FF00H,0,Fnt^,FALSE);
 ELSE
  ParamStr(S,1);
  IF FIO.Exists(S) THEN
   F:=FIO.Open(S);
   A:=FIO.RdBin(F,Fnt^,2); (* Size record *)
   A:=FIO.RdBin(F,Fnt^,4096);
   FIO.Close(F);
  ELSE
   CoreFont.GetSetFont(0FF00H,0,Fnt^,FALSE);
   END;
  END;
 DoASmoothScroll("Hello, I could make this really long, but I'm a bit tired, "+
                 "so I'll stop here. Grtx to Lord Vader and The Emperor ",Fnt);
END Smooth.