MODULE SubDemo;
(* Submenu demo, XtdLib package, (C) by Marco van de Voort 1997

Written because PullDemo didn't show the submenus to clearly.

MENU.SRC belongs (also) to this demo! Menu.DEF not necessarily, since it
can be generated out of MENU.SRC! .SRC files reside in directory source.
Please note that Menu.SRC has changed since the last version, please
recompile! *)

FROM Window IMPORT WinType,Color;
FROM PullDown IMPORT PullOpen,PullHandle,GetPullKey,PullClose,PullDef,
PullObject,SubKey,TopSpeedCol;
FROM Lib IMPORT EnableBreakCheck;
FROM ELib IMPORT GetKey,StrStr;
FROM Str IMPORT Length;
FROM Menu3 IMPORT Setup;

IMPORT IO,Menu,Window,PullDown;

TYPE    StrArr  = ARRAY[0..400] OF CHAR;
        StrPoint= POINTER TO StrArr;

CONST WrLn=CHR(13)+CHR(10);
      SubMenuSubMenu= WrLn+ "You pressed help on a submenu.  " +WrLn+
                   "Press escape to make this window disappear," +WrLn+
                   "then press enter to open the submenu.";

PROCEDURE WrSubLab(S:ARRAY OF CHAR);
(* Rough procedure, writes the S on a certain spot to the screen*)

BEGIN
 Window.Use (Window.FullScreen);
 Window.GotoXY(40,20);
 IO.WrCharRep(" ",40);
 Window.GotoXY(40,20);
 Window.TextColor(Magenta);
 IO.WrStr("Last picked label : ");
 Window.TextColor(Green);
 IO.WrStr(S);
END WrSubLab;

PROCEDURE WrSubSelect(S:ARRAY OF CHAR);
(* Writes the select text S to the screen, for submenus*)

BEGIN
 Window.CursorOff;
 Window.GotoXY(10,23);
 Window.TextColor(Window.Blue);
 IO.WrCharRep("",50);
 Window.GotoXY(10,23);
 Window.TextColor(Red);
 IO.WrStr("SubMenu:");
 Window.TextColor(Yellow);
 IO.WrStr(S);
END WrSubSelect;

CONST SubMenuDef=Window.WinDef(20,4,65,8,White,Black,FALSE,TRUE,FALSE,TRUE,
                            Window.DoubleFrame,Yellow,Black);

PROCEDURE WrHelp(S:ARRAY OF CHAR);

VAR L : WinType;
    A : CARDINAL;

BEGIN
 L:=Window.Open(SubMenuDef);
 Window.Use (L);
 IO.WrLn;
 IO.WrStr("This is the help for : ");
 IO.WrStr(S);
 A:=GetKey();
 Window.Close(L);
END WrHelp;

PROCEDURE SubMenu(InCode,H:CARDINAL):CARDINAL;

VAR A : CARDINAL;

BEGIN
   CASE InCode OF
   | MAX(CARDINAL)  : RETURN 0;
   END;
RETURN 0 ;
END SubMenu;

PROCEDURE SubMenuSelect(InCode,H:CARDINAL):CARDINAL;

BEGIN
 Window.Use(Window.FullScreen);
    CASE InCode OF
   | MAX(CARDINAL)  : RETURN 0;
   END;
RETURN 0 ;
END SubMenuHelp;

CONST SetupDef=PullDef(TopSpeedCol,TRUE,22,SubMenu,SubMenuHelp,SubMenuSelect);



VAR
    H   : PullHandle;
    I   : CARDINAL;
    S   : ARRAY[0..79] OF CHAR;

BEGIN
 (* PullOpen is used, but FirstSub is a SubMenu object, see Menu.DEF!
    In the definition of FirstSub, some of the fields are NIL to indicate
     a SubMenu. *)
 H:=PullOpen(PullObject(Setup),SetupDef); (* textual, colors and procedure
                                              data transfer to PullDown,
                                               sets up handle*)
 I:=SubKey(H,2,13);                        (* SubMenu on coordinates (2,13)*)
 PullClose(H);                             (* Close SubMenu, release memory.*)
(* H:=PullOpen(PullObject(FirstSub),SetupDef); (* textual, colors and procedure
                                              data transfer to PullDown,
                                               sets up handle*)
 I:=SubKey(H,2,13);                        (* SubMenu on coordinates (2,13)*)
 PullClose(H);                             (* Close SubMenu, release memory.*) *)

END SubDemo.