MODULE DateTest;
(* Part of the Xtdlib package, (C) 1997 Marco van de Voort

A simple procedure to display all functionality of DaTiToStr, also I'm not
used to the 12-hours system anymore, so I set up a series of tests for you
to examine

Is 24-hour 0:01  12:01 PM? Or 12:01 AM?
Is 24-hour 12:01 12:01 AM? Or 12:01 PM?

I implemented 0:01 as 12:01 PM, but this can be changed easily.*)

FROM ELib IMPORT DaTiToStr;

IMPORT IO;

CONST
FormStr=
 "%H:%M:%S  %h:%m:%s  %U:%m %a  %u:%m %A  %D-%O-%Y %d-%o-%y, %W %J %D%L, %y";

FormStr2=
 "%i%H:%M:%S  %h:%m:%s  %U:%m %a  %u:%m %A  %D-%O-%Y %d-%o-%y, %W %J %D%L, %y";

FormStr3=
 "%i%H:%M:%S  %h:%m:%s  %U:%m %a  %u:%m %A  %I%D-%O-%Y %d-%o-%y, %W %J %D%L, %y";

VAR Date:ARRAY[0..255] OF CHAR;

PROCEDURE ShowString(FStr :ARRAY OF CHAR);

BEGIN
 DaTiToStr(12,12,13,15,5,2006,FStr,Date); IO.WrStr(Date); IO.WrLn;
 DaTiToStr(13,12,13,15,5,2006,FStr,Date); IO.WrStr(Date); IO.WrLn;
 DaTiToStr(0 ,12,13,15,5,2006,FStr,Date);  IO.WrStr(Date); IO.WrLn;
 DaTiToStr(23,12,13,15,5,2006,FStr,Date); IO.WrStr(Date); IO.WrLn; IO.WrLn;
END ShowString;

BEGIN (* The differences in the strings are just to show the %i switch*)
 ShowString(FormStr);
 ShowString(FormStr2);
 ShowString(FormStr3);
END DateTest.