MODULE ArId;
(*Demo of module ELib.ArchiveMethod, XtdLib package (C) 1996

If you write something for mail, web or anything else which manages files which
are not your own datafiles, you'll run into archives, and then ArchiveMethod
becomes interesting, to detect which unpacker should be used.

The procedure ArchiveMethod detects the most common DOS-archivers, AND DETECTS
THEM BY SCANNING THE ARCHIVE, IT DOES NOT USE THE EXTENSION!

The program could be made more robust (..\..\ things like in parameter may
cause problems) by adding a Eval(ELib.ExpPath) just before the ArchiveMethod
statement. ExpPath requires however some additional code to circumvent the
problems on network (cdrom fixed allthough it is also managed by a driver)
drives. See ELib.DEF *)

IMPORT FIO,IO;
FROM Lib IMPORT ParamCount,ParamStr;
FROM ELib IMPORT ArchiveType,ArchiveMethod;
FROM Str  IMPORT RCharPos,Copy,Append;

VAR
  FileName,
  S        : ARRAY[0..99] OF CHAR;
  Return   : ArchiveType;
  D        : FIO.DirEntry;
  Fl       : BOOLEAN;
  A        : CARDINAL;

BEGIN
 IF ParamCount() = 1 THEN
   ParamStr(FileName,1);
   Fl:=FIO.ReadFirstEntry(FileName,FIO.FileAttr{},D);
   (* D.Name does not contain directory information which can exist in
       FileName; the program circumvents this by cutting it from FileName
       when necessary *)
   A:=RCharPos(FileName,"\");
   IF A= MAX(CARDINAL) THEN
    A:=0;
    END;
   FileName[A]:=CHR(0);
   IF A # 0 THEN
    Append(FileName,"\");
    END;
   IF Fl THEN
    REPEAT
     Copy(S,FileName);
     Append(S,D.Name);
     Return   := ArchiveMethod(S);
     IO.WrStrAdj(S,-35);
     CASE Return OF
     | ARJ     : IO.WrStr("ARJ "); IO.WrLn;
     | PAK     : IO.WrStr("PAK ");
     | LZH     : IO.WrStr("LZH ");
     | ARC     : IO.WrStr("ARC ");
     | ZOO     : IO.WrStr("ZOO ");
     | ZIP     : IO.WrStr("ZIP ");
     | RAR     : IO.WrStr("Rar ");
     | UC2     : IO.WrStr("Uc2 ");
     | Q       : IO.WrStr("Q   ");
     | none    : IO.WrStr("Unknown!");
     ELSE
      IO.WrStr('Not Found');
      END;
    IO.WrLn;
    UNTIL NOT FIO.ReadNextEntry(D);
    END;
 ELSE
  IO.WrStr('No parameter');
  IO.WrLn;
  END;
END ArId.
