MODULE ChrDem2;
(* Demo belonging to CoreFont(XtdLib package), (C) by Marco van de Voort 1996
   VGA/EGA only!!*)

FROM CoreFont IMPORT BChar,FontP,GetSetFont,MirrorBitset8;
FROM Storage IMPORT ALLOCATE,DEALLOCATE;
FROM Lib IMPORT ParamStr,ParamCount;
FROM Str IMPORT Caps;
FROM CoreCrt IMPORT ChangeMode;

IMPORT IO;

VAR OldFnt : FontP;
    A,B    : CARDINAL;
    Doit   : CARDINAL;
    S      : ARRAY[0..7] OF CHAR;

BEGIN
 Doit:=0;
 IF ParamCount()>0 THEN
  ParamStr(S,1);
  Caps(S);
  CASE S[0] OF
   | "A" : Doit:=0; (* Delete all even rows in character, space effect *)
   | "B" : Doit:=1; (* AND all bytes in font with BYTE(170), script effect*)
   | "C" : Doit:=2; (* Delete all rows except rows 2,5,8,11,14, effect like A *)
   | "D" : Doit:=3; (* AND all bytes in font with BYTE(153),
                                     stronger effect than B*)
   | "E" : Doit:=4; (* Mirror entire font with respect to Y-axis *)
   | "F" : Doit:=5; (* Mode reset, restore standard font *)
  ELSE
   IO.WrStr(" Usage : ChrDem2 A|B|C|D|E|F "); IO.WrLn;
   END;
  END;
 NEW(OldFnt);
 GetSetFont(255*256,0,OldFnt^,FALSE); (* Get current font *)
 IF Doit<5 THEN
  FOR A:=0 TO 255 DO
   IF Doit=2 THEN
    OldFnt^[A][0]:=0;   OldFnt^[A][1]:=0;
    OldFnt^[A][3]:=0;   OldFnt^[A][4]:=0;
    OldFnt^[A][6]:=0;   OldFnt^[A][7]:=0;
    OldFnt^[A][9]:=0;   OldFnt^[A][10]:=0;
    OldFnt^[A][12]:=0;  OldFnt^[A][13]:=0;
    OldFnt^[A][15]:=0;
   ELSE
     FOR B:=0 TO 7 DO
      CASE Doit OF
      | 0 : OldFnt^[A][B*2]:=0;
      | 1 : OldFnt^[A][B*2]:=BYTE(CARDINAL(OldFnt^[A][B*2]) AND 170);
            OldFnt^[A][B*2+1]:=BYTE(CARDINAL(OldFnt^[A][B*2+1]) AND 170);
      | 3 : OldFnt^[A][B*2]:=BYTE(CARDINAL(OldFnt^[A][B*2]) AND 153);
            OldFnt^[A][B*2+1]:=BYTE(CARDINAL(OldFnt^[A][B*2+1]) AND 153);
      | 4 : OldFnt^[A][B*2]:=MirrorBitset8(OldFnt^[A][B*2]);
            OldFnt^[A][B*2+1]:=MirrorBitset8(OldFnt^[A][B*2+1]);
       END;
      END;
     END;
  END;
 GetSetFont(255*256,0,OldFnt^,TRUE); (* Activate font *)
ELSE
 ChangeMode(3); (* Doit=5, modereset, restores original font*)
 END;

 DISPOSE(OldFnt);
END ChrDem2.