MODULE Prime;
(* This must be one of the very first M2 experiments of mine, probably bases
on an older existing M2 or pascal source.

I can't remember what I created it for (DES?) or where it originates from.

No copyrights, at least as far as I'm concerned :-)

Calculates the first 16383 primes. Keeps them both in memory and on disc
(in prime.txt).
*)

IMPORT FIO,Storage,Crt,IO;
FROM CoreCrt IMPORT SetCurSize;

CONST
  FirstPrime = 2;
  MaxPrimes  = 16383; (* Limit 64k For one Array, little more work for more *)

TYPE Arr=ARRAY[1..MaxPrimes] OF LONGCARD;

VAR
  Primes      : POINTER TO Arr;

  PrimesFound : CARDINAL;
  TestNumber  : LONGCARD;
  Count       : CARDINAL;

  IsPrime     : BOOLEAN;
  F           : FIO.File;
  Buf         : ARRAY[0..4096] OF BYTE;

BEGIN
  SetCurSize(0,0);
  Storage.ALLOCATE(Primes,SIZE(Arr));
  F:=FIO.Create('Prime.txt');
  FIO.AssignBuffer(F,Buf);
  PrimesFound := 1;
  TestNumber  := FirstPrime + 1;

  FOR Count := 1 TO MaxPrimes DO
    Primes^[Count] := 0;
    END;

  Primes^[1] := FirstPrime;

  REPEAT
    Count   := 1;
    IsPrime := TRUE;

    REPEAT
      IF ODD (TestNumber) THEN
        IF TestNumber MOD Primes^[Count] = 0 THEN
          IsPrime := FALSE;
          END;
       ELSE
        IsPrime:=FALSE;
        END;
       INC (Count);
    UNTIL (IsPrime = FALSE) OR (Count > PrimesFound);

    IF IsPrime = TRUE THEN
     INC (PrimesFound);
     Primes^[PrimesFound] := TestNumber;
     FIO.WrLngCard (F,TestNumber,8);
     Crt.GotoXY(10,10);
     IO.WrCard(PrimesFound,10);
     END;
    INC (TestNumber);
  UNTIL PrimesFound = MaxPrimes;
  FIO.Close(F);
END Prime.
